(* EPITA SPE 2013/2014        *)
(* Controle 1 - Novembre 2013 *)
(* question12                 *)

type peano =
  | Zero
  | Succ of peano
  | Pred of peano

let normalize = function
  | Zero -> Zero
  | p ->
    begin
      let (pos,neg) = (Stack.create (), Stack.create ()) in
      let rec count = function
        | Zero -> ()
        | Succ p -> Stack.push 1 pos; count p
        | Pred p -> Stack.push 1 neg; count p
      in
      let rec rebuild (b,p,s) =
        if Stack.is_empty s then p
        else
          begin
            ignore (Stack.pop s);
            if b then rebuild (b, Succ p, s)
            else rebuild (b, Pred p, s)
          end
      in
      count p;
      while (not (Stack.is_empty pos)) && (not (Stack.is_empty neg)) do
        ignore (Stack.pop pos);
        ignore (Stack.pop neg);
      done;
      rebuild (if Stack.is_empty neg then (true,Zero,pos) else (false,Zero,neg))
    end

let add p1 p2 =
  let rec _add = function
    | (Zero, p) | (p, Zero) -> p
    | (Succ p, ((Succ _) as p')) -> _add (p, Succ p')
    | (Pred p, ((Pred _) as p')) -> _add (p, Pred p')
    | (Succ p, Pred p')
    | (Pred p, Succ p') -> _add (p, p')
  in _add (p1,p2)
