(* EPITA SPE 2013/2014        *)
(* Controle 1 - Novembre 2013 *)
(* question07                 *)

module Q = Question07

let strmap f s =
  let s' = String.copy s in
  for i = 0 to (String.length s) - 1 do
    s'.[i] <- f s.[i]
  done; s'


let rot47 s =
  strmap (
    fun chr ->
      let c = Char.code chr in
      if c <= 32 || c > 127 then chr
      else Char.chr ((((c - 33) + 47) mod 94) + 33)
  ) s

let main () =
  begin
    let q = new Test_frame.qString 7 in
    q#beginParse;
    q#init;
    let s = q#makeString in
    Format.printf "@[<v>";
    Format.printf "s = %S" s;
    Format.printf "@,pipe s [lowercase; capitalize] = %S"
      (Q.pipe s [String.lowercase; String.capitalize]);
    Format.printf "@,pipe s [uppercase; uncapitalize] = %S"
      (Q.pipe s [String.uppercase; String.uncapitalize]);
    Format.printf "@,pipe s [rot47] = %S"
      (Q.pipe s [rot47]);
    Format.printf "@,pipe s [rot47; rot47] = %S"
      (Q.pipe s [rot47; rot47]);
    Format.printf "@]@.";
    exit 0;
  end

let _ = main ()
