(* EPITA SPE 2013/2014        *)
(* Controle 1 - Novembre 2013 *)
(* question09                 *)

module Q = Question09

let build_list q =
  let l = Q.({size = q#getSize; inner = None; }) in
  let rec aux l = function
    | 0 -> l
    | n -> aux (Some Q.({content = q#getN; next = l})) (n-1)
  in
  l.Q.inner <- aux None q#getSize; l

let print_list l =
  let rec aux = function
    | None -> ()
    | Some cell
      ->
      begin
        Format.printf "@;%02d;" cell.Q.content;
        aux cell.Q.next;
      end
  in
  begin
    Format.printf "@;(size=%d)[@[<b 1>" l.Q.size;
    aux l.Q.inner;
    Format.printf "@]@;]";
  end

let main () =
  begin
    let q = new Test_frame.qSeedSizeInt 9 10 in
    q#beginParse;
    q#init;
    let l = build_list q in

    Format.printf "@[<b 1>l =";
    print_list l;
    Format.printf "@]@.";

    Format.printf "@[<h>f x = x*x@]@.";

    Q.update (fun x -> x*x) l;

    Format.printf "@[<h>update f l@]@.";

    Format.printf "@[<b 1>l =";
    print_list l;
    Format.printf "@]@.";

    exit 0;
  end

let _ = main ()
