(* EPITA SPE 2013/2014        *)
(* Controle 1 - Novembre 2013 *)
(* question11                 *)

module Q = Question11

let translate (x,y) =
  Complex.({
    re = (float (x-128)) /. 64.;
    im = (float (y-128)) /. 64.
  })

let draw n =
  begin
    Graphics.open_graph " 256x256";
    Graphics.set_color Graphics.black;
    for i = 0 to 255 do
      for j = 0 to 255 do
        if not (Q.escape (translate (i,j)) n) then
          Graphics.plot i j
      done
    done;
    ignore (Graphics.read_key ());
  end

let main () =
  begin
    let q = new Test_frame.qSeedSizeOption 11 256 in
      q#beginParse;
      q#init;
      let s = q#getSize in
        if q#option then
          draw s
        else
          begin
            Format.printf "@[<v>";
            for i = 1 to s do
              let c = translate (q#getN,q#getN) in
                Format.printf "@[<b 4>(%g,%g) :@;" c.Complex.re c.Complex.im;
                if Q.escape c s then
                  Format.printf "converge"
                else
                  Format.printf "diverge";
                Format.printf "@]@,";
            done;
            Format.printf "@]@.";
          end;
        exit 0
  end

let _ = main ()
