(* EPITA SPE 2013/2014        *)
(* Controle 1 - Novembre 2013 *)
(* question12                 *)

module Q = Question12

let rec build q p = function
  | 0 -> p
  | n ->
    let z = (q#getN - 50) in
    if z = 0 then p
    else
      if z < 0 then build q (Q.Pred p) (n-1)
      else build q (Q.Succ p) (n-1)

let print ?(pref="p") p =
  let rec aux = function
    | Q.Zero -> Format.printf "@;Zero@,"
    | Q.Succ p ->
      Format.printf "@;Succ (@[<b -2>";
      aux p;
      Format.printf "@]@,)"
    | Q.Pred p ->
      Format.printf "@;Pred (@[<b -2>";
      aux p;
      Format.printf "@]@,)"
  in
  begin
    Format.printf "@[<b>%s =@,@[<b 1>" pref;
    aux p;
    Format.printf "@]@,@]@.";
  end

let main () =
  begin
    let q = new Test_frame.qSeedSizeInt 12 101 in
    q#beginParse;
    q#init;
    let p = build q Q.Zero q#getSize in
    let p1 = build q Q.Zero (q#getSize/2) in
    let p2 = build q Q.Zero (q#getSize/2) in
    print p;
    print ~pref:"normalize p" (Q.normalize p);
    print ~pref:"p1" p1;
    print ~pref:"p2" p2;
    print ~pref:"p1 + p2" (Q.add p1 p2);
    exit 0;
  end

let _ = main ()
